/* **********
  greetings.c

  This program welcomes a user after he enters the time
  in format HH:MM:SS
  
 ********** */

#include <stdio.h>

/*
  This simple funtion check current time
  (not a hours, just a minutes).
 */
int whatstime(int ctime) {
  if((ctime == 0) || (ctime == 24))
    return 0;
  else if(ctime == 30)
    return 6;
  else if((ctime > 0 ) && (ctime < 30)) {
    if(ctime <= 5)
      return 1;
    else if(ctime <= 10)
      return 2;
    else if(ctime <= 15)
      return 3;
    else if(ctime <= 20)
      return 4;
    else if(ctime <= 25)
      return 5;
  }
  else if((ctime > 30) && (ctime < 60)) {
    if(ctime <= 35)
      return 7;
    else if(ctime <= 40)
      return 8;
    else if(ctime <= 45)
      return 9;
    else if(ctime <= 50)
      return 10;
    else if(ctime <= 55)
      return 11;
  }
  else return -1;
}

int main() {
  typedef char TString[60];
  
  TString greetings[4]={"Good morning!\n", "Good afternoon!\n", 
                        "Good evening!\n", "Good night!\n"};
  
  TString currenttime[12]={"o'clock",          // 0
                           "five past",        // 1
                           "ten past",         // 2
                           "quarter past",     // 3
                           "twenty past",      // 4
                           "twenty-five past", // 5
                           "half past",        // 6
                           "twenty-five to",   // 7
                           "twenty to",        // 8
                           "quarter to"        // 9
                           "ten to",           // 10
                           "five to"};         // 11
  
  TString hoursnames[23]={"one", "two",                    // 0, 1
                          "three","four",                  // 2, 3
                          "five", "six",                   // 4, 5
                          "seven", "eight",                // 6, 7
                          "nine", "ten",                   // 8, 9
                          "eleven", "twelve",              // 10, 11
                          "thirteen", "fourteen",          // 12, 13
                          "fifteen", "sixteen",            // 14, 15
                          "seventeen", "eighteen",         // 16, 17
                          "twenty", "twenty-one",          // 18, 19
                          "twenty-two","twenty-three",     // 20, 21
                          "twenty-four (It's a midnight!)"}; // 22
  
  int iHours, iMinutes, iSeconds;
  int iResult;
  int iTime;

  do {
    /* Clear bufer */
    fflush(stdin);
    
    /* We asked for time, and check result after an user hit <Enter>  */
    printf("Please enter a time:\n> ");
    iResult = scanf("%d:%d:%d", &iHours, &iMinutes, &iSeconds);
    if(!iResult) {
      printf("Please enter time in format: HH:MM:SS\007\n> ");
      continue;
    }

    if((iHours < 0)   || (iHours > 24)   ||
       (iMinutes < 0) || (iMinutes > 60) ||
       (iSeconds < 0) || (iSeconds > 60)) {
      printf("Error: incorrect time!\007\n");
      iResult = 0;
      continue;
    }

    iTime = whatstime(iMinutes);
    if(iTime == -1) {
      printf("What a Terrible Failure!..\007\n");
      iResult = 0;
      continue;
    }

    /* *** It's OK. Lets go. *** */
    
    /* Now, we are creating and printing our greeting... */    
    if((iHours <= 6) || (iHours >= 22))
      printf("%s", greetings[3]);
    else if((iHours > 6) && (iHours < 12))
      printf("%s", greetings[0]);
    else if((iHours >= 12) && (iHours <= 18))
      printf("%s", greetings[1]);
    else
      printf("%s", greetings[2]);
    
    if(iTime == 0)
      printf("It's %d %s\n", iHours, currenttime[iTime]);
    else
      printf("It's %s %s.\n", currenttime[iTime], 
             hoursnames[((iHours == 0) || (iHours == 24))?22:iHours-1]);
    
  } while(!iResult);

  
  return 0;
}
